var t1, t2, t3;     // three turtles
var x, y;           // location of target

function setup() {
    createCanvas(400, 500);
    background(0);
    t1 = makeTurtle(width / 2 + random(-100, 100), height / 2 + random(-100, 100));
    t2 = makeTurtle(width / 2 + random(-100, 100), height / 2 + random(-100, 100));
    t3 = makeTurtle(width / 2 + random(-100, 100), height / 2 + random(-100, 100));
    t1.lowerPen();
    t1.setColor(color(255, 0, 0));
    t1.setWeight(3);
    t2.lowerPen();
    t2.setColor(color(0, 255, 0));
    t2.setWeight(3);
    t3.lowerPen();
    t3.setColor(color(0, 0, 255));
    t3.setWeight(3);
    frameRate(40);
}
 
function draw() {
    t1.forward(1);
    t2.forward(2);
    t3.forward(3);
    x = width * noise(frameCount / 1000);
    y = height * noise(10000 + frameCount / 1000);
    strokeWeight(5);
    stroke(128);
    point(x, y);
    t1.turnToward(x, y, 1);
    t2.turnToward(x, y, 1);
    t3.turnToward(x, y, 1);
    t1.left(random(-5, 5));
    t2.left(random(-5, 5));
    t3.left(random(-5, 5));
}



// TURTLE GRAPHICS CODE ONLY - NO SETUP/DRAW (DO NOT EDIT)
// Copy and paste this into your program at the end of its file
// API:
// makeTurtle(x, y) -- make a turtle at x, y, facing right, pen down
// left(d) -- turn left by d degrees
// right(d) -- turn right by d degrees
// forward(p) -- move forward by p pixels
// back(p) -- move back by p pixels
// lowerPen() -- pen down
// raisePen() -- pen up
// goto(x, y) -- go straight to this location
// setColor(color) -- set the drawing color
// setWeight(w) -- set line width to w
// face(d) -- turn to this absolute direction in degrees
// angleTo(x, y) -- what is the angle from my heading to location x, y?
// turnToward(x, y, d) -- turn by d degrees toward location x, y
// distanceTo(x, y) -- how far is it to location x, y?

function makeTurtle(tx, ty) {
    var turtle = {x: tx, y: ty,
                  angle: 0.0, 
                  penDown: true,
                  color: color(128),
                  weight: 1,
                  left: turtleLeft, right: turtleRight,
                  forward: turtleForward, back: turtleBack,
                  lowerPen: turtleLowerPen, raisePen: turtleRaisePen,
                  goto: turtleGoTo, angleto: turtleAngleTo,
                  turnToward: turtleTurnToward,
                  distanceTo: turtleDistTo, angleTo: turtleAngleTo,
                  setColor: turtleSetColor, setWeight: turtleSetWeight,
                  face: turtleFace};
    return turtle;
}

function turtleLeft(d) {
    this.angle -= d;
    this.angle %= 360;
}


function turtleRight(d) {
    this.angle += d;
    this.angle %= 360;
}


function turtleForward(p) {
    var rad = radians(this.angle);
    var newx = this.x + cos(rad) * p;
    var newy = this.y + sin(rad) * p;
    this.goto(newx, newy);
}


function turtleBack(p) {
    this.forward(-p);
}


function turtleLowerPen() {
    this.penDown = true;
}


function turtleRaisePen() {
    this.penDown = false;
}


function turtleGoTo(newx, newy) {
    if (this.penDown) {
      stroke(this.color);
      strokeWeight(this.weight);
      line(this.x, this.y, newx, newy);
    }
    this.x = newx;
    this.y = newy;
}


function turtleDistTo(x, y) {
    return dist(this.x, this.y, x, y);
}


function turtleAngleTo(x, y) {
    var absAngle = degrees(atan2(y - this.y, x - this.x));
    var angle = ((absAngle - this.angle) + 360) % 360;
    print(absAngle + " " + this.angle + " " + angle);
    return angle;
}


function turtleTurnToward(x, y, d) {
    var angle = this.angleTo(x, y);
    if (angle < 180) {
        this.angle += d;
    } else {
        this.angle -= d;
    }
}


function turtleSetColor(c) {
    this.color = c;
}


function turtleSetWeight(w) {
    this.weight = w;
}


function turtleFace(angle) {
    this.angle = angle;
    this.angle %= 360;
}

